package abcscriptgen;

import java.io.FileWriter;
import java.io.BufferedWriter;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.InputStream;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;

//trida pro spusteni systemu ABC a programu permute
public class runnerPermAbc {

    public runnerPermAbc() {
        
    }
    //fukce zajistujici spousteni systemu ABC v pripade provadeni testovani s permutacemi
    public boolean abcExec(int it, boolean printErrorA) {                   
        boolean error = false;
        try {               
            Process process = new ProcessBuilder(System.getProperty("user.dir") + "\\abc\\abc.exe", "-f", System.getProperty("user.dir") + "\\scripts\\temp.scr").start();           
            InputStream is = process.getInputStream();
            InputStreamReader isr = new InputStreamReader(is);
            BufferedReader br = new BufferedReader(isr);
            BufferedWriter bw = new BufferedWriter(new FileWriter(System.getProperty("user.dir") + "\\errorlogs\\abcErrors.log", true));
            try {
                process.waitFor();
            } catch (InterruptedException ex) {
                Logger.getLogger(GUI.class.getName()).log(Level.SEVERE, null, ex);
            }
            String line;
            while ((line = br.readLine()) != null) {
                if (!line.equals(""))
                    error = true;
                if (printErrorA) {
                    bw.write(line);
                    bw.newLine();
                }             
            }
            process.destroy();
        } catch (IOException ex) {
            Logger.getLogger(GUI.class.getName()).log(Level.SEVERE, null, ex);
        }
        return error;
    }
    //fukce zajistujici spousteni systemu ABC v pripade provadeni testovani bez permutaci
    public boolean abcExecGivenScript(int it, boolean printErrorA, String script) {                   
        boolean error = false;
        try {               
            Process process = new ProcessBuilder(System.getProperty("user.dir") + "\\abc\\abc.exe", "-f", System.getProperty("user.dir") + "\\scripts\\" + script).start();           
            BufferedReader br = new BufferedReader (new InputStreamReader(process.getInputStream())); 
            BufferedWriter bw = new BufferedWriter(new FileWriter(System.getProperty("user.dir") + "\\errorlogs\\abcErrors.log", true));
            String line="";
            boolean first = true;
            while ((line = br.readLine()) != null) {
                if (!line.equals(""))
                    error = true;
                if (printErrorA) {
                    if (first) bw.write("Chyba v systemu ABC");
                    bw.write(line);
                    bw.newLine();
                    first = false;
                }             
            }
            try {
                process.waitFor();
            } catch (InterruptedException ex) {
                Logger.getLogger(GUI.class.getName()).log(Level.SEVERE, null, ex);
            }            
            process.destroy();
            br.close();
            bw.close();
        } catch (IOException ex) {
            Logger.getLogger(GUI.class.getName()).log(Level.SEVERE, null, ex);
        }
        return error;
    }
    //fukce zajistujici spousteni permutaci
    public boolean permExec(int it, String perm, String fileOrig, boolean printErrorP) {
        boolean error = false;
        String fileNew = fileOrig.substring(0, fileOrig.lastIndexOf(".")) + perm + fileOrig.substring(fileOrig.lastIndexOf("."));
        String p = "";
        if (perm.equals("PI"))
            p = "-i";
        if (perm.equals("PO"))
            p = "-o";
        if (perm.equals("N"))
            p = "-n";
        if (perm.equals("T"))
            p = "-t";
        try {                              
            Process process = new ProcessBuilder(System.getProperty("user.dir") + "\\permute\\permute.exe", p, System.getProperty("user.dir") + "\\circuits\\" + fileOrig, System.getProperty("user.dir") + "\\permuted\\" + fileNew).start();
            BufferedReader br = new BufferedReader (new InputStreamReader(process.getInputStream())); 
            BufferedWriter bw = new BufferedWriter(new FileWriter(System.getProperty("user.dir") + "\\errorlogs\\permErrors.log", true));
            String line="";
            boolean first = true;
            while ((line = br.readLine()) != null) {
                if (!line.equals(""))
                    error = true;
                if (printErrorP) {
                    if (first) bw.write("Chyba pri permutaci souboru " + fileOrig);
                    bw.write(line);
                    bw.newLine();
                    first = false;
                }
            }
            try {
                process.waitFor();
            } catch (InterruptedException ex) {
                Logger.getLogger(GUI.class.getName()).log(Level.SEVERE, null, ex);
            }
                        
            process.destroy();
            br.close();
            bw.close();
        } catch (IOException ex) {
            Logger.getLogger(GUI.class.getName()).log(Level.SEVERE, null, ex);
        }
        return error;
    }
       
}
